
RunTests	PROC
LOCAL lpStr:DWORD

		invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
		cmp	eax,BST_CHECKED
		jnz @F
			invoke LLIST_create,100*sizeof MEMBER
			or	eax,eax
			jz @End
			mov	lpMyList,eax
			invoke Test1
			invoke LLIST_destroy,lpMyList
@@:
		invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
		cmp	eax,BST_CHECKED
		jnz @End
			invoke LARRAY_create,dwElementSize,dwSubArrayLen
			or	eax,eax
			jz @End
			mov	lpMyList,eax
			invoke Test2
			invoke LARRAY_destroy,lpMyList
@End:
		ret
RunTests	ENDP

Test1		PROC USES ebx esi
LOCAL memoryStatus:MEMORYSTATUS
LOCAL dwMemory:DWORD

		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sText1

		invoke GlobalMemoryStatus,addr memoryStatus
		mov	eax,memoryStatus.dwAvailPhys
		add	eax,memoryStatus.dwAvailPageFile
		mov	dwMemory,eax

		mov	esi,lpMyList
		ASSUME esi:PTR LINKED_LIST
		mov	ebx,dwMemberCount

	timer_begin 1,HIGH_PRIORITY_CLASS
@1: ; Insert members
		mov	eax,dwMode
		or	eax,eax
		jz @F
		cmp	eax,1
		jz @F
		; invoke rand,dwNumberOfMembers
	@@:
		invoke LLIST_insert,esi,eax,sizeof MEMBER
		or	eax,eax
		jz @F
		sub	ebx,1
		jnz @1
	@@:
	timer_end
		invoke wsprintf,offset sBuffer,offset sFormat1,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

@2: ; Read through the whole list
		xor	ebx,ebx
		mov	eax,[esi].lpHead
	@@:
		add	ebx,1
		mov	eax,(LINKED_MEMBER PTR [eax]).lpNextLink
		or	eax,eax
		jnz @B

		invoke wsprintf,offset sBuffer,offset sFormat2,ebx
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

		invoke GlobalMemoryStatus,addr memoryStatus
		mov	eax,memoryStatus.dwAvailPhys
		add	eax,memoryStatus.dwAvailPageFile
		neg	eax
		add	eax,dwMemory
		shr	eax,20
		invoke wsprintf,offset sBuffer,offset sTextMem,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

		mov	ebx,dwMemberCount
		timer_begin 1,HIGH_PRIORITY_CLASS
@3: ; Remove members
		mov	eax,dwMode
		or	eax,eax
		jz @F
		cmp	eax,1
		jz @F
		; invoke rand,dwNumberOfMembers
	@@:
		invoke LLIST_remove,esi,eax,NULL
		sub	ebx,1
		jnz @3
	@@:
	timer_end
		invoke wsprintf,offset sBuffer,offset sFormat3,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer


		ASSUME ebx:NOTHING
		ret

Test1		ENDP

Test2		PROC USES ebx esi
LOCAL memoryStatus:MEMORYSTATUS
LOCAL dwMemory:DWORD
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sText2

		invoke GlobalMemoryStatus,addr memoryStatus
		mov	eax,memoryStatus.dwAvailPhys
		add	eax,memoryStatus.dwAvailPageFile
		mov	dwMemory,eax

		mov	esi,lpMyList
		ASSUME esi:PTR LINKED_ARRAY
		mov	ebx,dwMemberCount

	timer_begin 1,HIGH_PRIORITY_CLASS
@1: ; Insert members
		mov	eax,dwMode
		or	eax,eax
		jz @F
		cmp	eax,1
		jz @F
		; invoke rand,dwNumberOfMembers
	@@:
		invoke LARRAY_insert,esi
		or	eax,eax
		jz @F
		sub	ebx,1
		jnz @1
	@@:
	timer_end
		invoke wsprintf,offset sBuffer,offset sFormat1,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

@2: ; Read through the whole list
		xor	ebx,ebx
		mov	eax,[esi].lpHead
	@@:
		add	ebx,1
		mov	eax,(LINKED_SUBARRAY PTR [eax]).lpNextLink
		or	eax,eax
		jnz @B

		invoke wsprintf,offset sBuffer,offset sFormat2,ebx
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

		invoke GlobalMemoryStatus,addr memoryStatus
		mov	eax,memoryStatus.dwAvailPhys
		add	eax,memoryStatus.dwAvailPageFile
		neg	eax
		add	eax,dwMemory
		shr	eax,20
		invoke wsprintf,offset sBuffer,offset sTextMem,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer

		mov	ebx,dwMemberCount
	timer_begin 1,HIGH_PRIORITY_CLASS
@3: ; Remove members
		mov	eax,dwMode
		or	eax,eax
		jz @F
		cmp	eax,1
		jz @F
		; invoke rand,dwNumberOfMembers
	@@:
		invoke LARRAY_remove,esi,eax
		sub	ebx,1
		jnz @3
	@@:
	timer_end
		invoke wsprintf,offset sBuffer,offset sFormat3,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sBuffer


		ASSUME ebx:NOTHING
		ret

Test2		ENDP
